package com.cloud.insurance.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 盘存表
 * </p>
 *
 * @author yuanxing
 * @since 2021-11-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("TAKE_INVENTORY")
@ApiModel(value="TakeInventory对象", description="盘存表")
public class TakeInventory extends Model<TakeInventory> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @TableId("ID")
    private String id;

    @ApiModelProperty(value = "盘存日期")
    @TableField("CREATE_TIME")
    private LocalDateTime createTime;

    @ApiModelProperty(value = "盘存人")
    @TableField("CREATE_USER")
    private String createUser;

    @ApiModelProperty(value = "盘存前库存量")
    @TableField("BEFORE_NUM")
    private Long beforeNum;

    @ApiModelProperty(value = "盘存后库存量")
    @TableField("AFTER_NUM")
    private Long afterNum;

    @ApiModelProperty(value = "所属定点机构编码")
    @TableField("TENANT_ID")
    private String tenantId;

    @ApiModelProperty(value = "关联库存id")
    @TableField("STORE_ID")
    private String storeId;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
